Join us in making Java a great platform for data science
========================================================

Tablesaw makes it easy to use Java for data science, but we can use your help. Here are some ways you can contribute today:

* Ask or answer questions
* Improve the documentation
* Report or fix a bug
* Implement tests for existing features
* Implement new features and enhancements
* Become a project maintainer

## About questions

Please use the project [Issues section on Github](https://github.com/jtablesaw/tablesaw/issues) to ask questions, tagging the issue as a "Question".

## Improve the documentation
All our docs are in the docs folder of the tablesaw repo, and they are all written in Markdown. To provide enhancements, follow the directions on how to implement featues and bugs below as the workflow is basically the same.

### Tests
We could always use better test coverage. If you see a gap you'd like to fill, follow the basic Github process outlined below. 

## Using Github to implement features and fix bugs (and improve documentation or add tests)

If you want to help out with one of our bugs or implement a new feature, here are some suggestions for success.  The basic process looks like this:

1. Fork Tablesaw
2. Clone your fork to your development machine
3. Create your issue branch
4. Implement your feature or fix the bug and push the results to your fork
5. Send us a pull request.

You can find more info about [creating a fork](https://help.github.com/articles/fork-a-repo/) and [pull request](https://help.github.com/articles/creating-a-pull-request-from-a-fork/) in the GitHub help articles. Our maintainers will review your pull request as soon as we can. You can find our project on Github at:

[https://github.com/jtablesaw/tablesaw](https://github.com/jtablesaw/tablesaw)

## What makes a good Pull Request?

To summarize:

* Address only one issue with a single pull request.
* For new functionality, have a conversation with one or more maintainers before putting in too much work. Opening an issue is a good way to start the conversation
* Requests with tests are the best
* Finally, We love small pull requests. That we we can find time to review them between work, and family, and watching Game of Thrones.

## What to Contribute?
### "Help Wanted" labels
Among the open bugs and feature requests, we've tagged some as "Help Wanted". This indicates that a fix should be relatively straightforward to address. We would, of course, LOVE help on some of the more challenging issues. Help Wanted simply means that this is a good place for a developer with limited knowlege of the library and/or limited experience with Java to jump in. 

### Javascript visualization libraries
Implement an interface for a Javascript plotting library (big job, we know), but the best Javascript libraries are awesome.
Email larry@tablesaw.tech if you have any questions, or use the comments for the issue.

## Become a Maintainer/Committer

We are actively seeking new maintainers for the project. The best way to get involved is to familiarize yourself with the project through use, and make a few minor changes/fixes. After that, introduce yourself by emailing info@tablesaw.tech and we’ll get in touch.
